#!/bin/csh

# Declaration of the fixed protein (receptor)
set PROT1=cut.1BGS.A
set PROTNAME1=1BGS.A
# Declaration of the mobile protein (ligand)
set PROT2=cut.1BGS.B
set PROTNAME2=1BGS.B
set SEPDIR = Proteins
# Initial positions of the ligand around the receptor (the total number depends on PROT1)
set Nsep1=1
set Nsep2=2
# Density of points for the initial positions of the ligand
set Dens=10.0
# Initial orientations of the ligand (between 1 and 21)
set Nrot1=1
set Nrot2=2
# Number of events for the ART method
set Neven=500
# remove previously generated files
rm global.dat
rm proteins.dat
rm input.dat
rm density.dat
# fill density file
echo $Dens > density.dat
# fill input file 
cp input input.dat
echo $Nsep1 >> input.dat
echo $Nsep2 >> input.dat
echo $Nrot1 >> input.dat
echo $Nrot2 >> input.dat
echo $Neven >> input.dat
# fill proteins file 
echo "'"$SEPDIR/$PROT1.pdb"'">proteins.dat
echo "'"$PROTNAME1"'">>proteins.dat
echo "'"$SEPDIR/$PROT2.pdb"'">>proteins.dat
echo "'"$PROTNAME2"'">>proteins.dat
# run the executables
../bin/Getarea.out
../bin/simulmain.out 
# copy the results 
cp position.dat Positions/$PROTNAME1.$PROTNAME2.position.dat
cp energy.dat Energy/$PROTNAME1.$PROTNAME2.energy.dat
cp global.dat Energy/$PROTNAME1.$PROTNAME2.$Nsep1-$Nsep2.global.dat

echo ' computation done'











